/*
Plugin Name: Psli-BingMaps
Author: psli 
Description: Maintenance function for plugin "Psli-BingMaps"
*/

// Global data
var psli_g_PolygonColor = new Microsoft.Maps.Color(100,20,0,20);
var psli_g_VerticeInitial = new Array();
var psli_g_ZoomEntity = new Array();
var psli_g_Vertice;
var psli_g_ZoneDraw;
var psli_g_Map;
var psli_g_BingKey;
var psli_g_MapOptions;
var psli_g_MapCenter;
var psli_g_zoomInitial;

// Data for guest
for (var i = 0; i < 20; i++)
	psli_g_ZoomEntity.push(new Microsoft.Maps.EntityCollection());

/**************************************************************************/
// JS Function used by admin script while setting up plugin
function psli_AdminUpdateMap() {
	psli_g_MapCenter = new Microsoft.Maps.Location(document.getElementById("lat").value, document.getElementById("lon").value);
	psli_g_zoomInitial = document.getElementById("zoom").value
	var pin = new Microsoft.Maps.Pushpin(psli_g_MapCenter);
	psli_g_Map.entities.clear();
	psli_g_Map.entities.push(pin);
	
	psli_g_Map.setView({center: psli_g_MapCenter, zoom: psli_g_zoomInitial});	
}

function psli_AdminMapClick(e) {
	if (e.targetType == "map") {
		var psli_l_Point = new Microsoft.Maps.Point(e.getX(), e.getY());
		psli_g_MapCenter = e.target.tryPixelToLocation(psli_l_Point);
		psli_g_zoomInitial = Math.round(psli_g_Map.getZoom());
		
		document.getElementById("lat").value = psli_g_MapCenter.latitude;
		document.getElementById("lon").value = psli_g_MapCenter.longitude;
		document.getElementById("zoom").value = psli_g_zoomInitial;
				
		var pin = new Microsoft.Maps.Pushpin(psli_g_MapCenter);
		psli_g_Map.entities.clear();
		psli_g_Map.entities.push(pin);
		
		psli_g_Map.setView({center: psli_g_MapCenter, zoom: psli_g_zoomInitial});
	}
}

function psli_InitAdminSetup () {
	psli_g_MapOptions = { 
		credentials: psli_g_BingKey, 
		showDashboard:false,
		showMapTypeSelector:false,
		showScalebar:false,
		mapTypeId: Microsoft.Maps.MapTypeId.road,
		center: psli_g_MapCenter,
		zoom: psli_g_zoomInitial
	};
	
	psli_g_Map = new Microsoft.Maps.Map(document.getElementById("myMap"), psli_g_MapOptions);
	Microsoft.Maps.Events.addHandler(psli_g_Map, "click", psli_AdminMapClick);
	var pin = new Microsoft.Maps.Pushpin(psli_g_MapCenter);
	psli_g_Map.entities.clear();
	psli_g_Map.entities.push(pin);
	psli_g_Map.setView({center: psli_g_MapCenter, zoom: psli_g_zoomInitial});
}
	
/**************************************************************************/
// JS Function used by admin script while editing category location	
function psli_MapsMouseOut (e) { 
	 document.getElementById("Coordonates").innerHTML = "";
}
	
function psli_InitGuestMap()
{
	psli_g_MapOptions = { 
		credentials: psli_g_BingKey, 
		showDashboard:false,
		showMapTypeSelector:false,
		showScalebar:false,
		mapTypeId: Microsoft.Maps.MapTypeId.road,
		center: psli_g_MapCenter,
		zoom: psli_g_zoomInitial
	};
	
	psli_g_Map = new Microsoft.Maps.Map(document.getElementById("myMap"), psli_g_MapOptions);
	Microsoft.Maps.Events.addHandler(psli_g_Map, "viewchangeend", psli_ViewChangeEnd);
	psli_g_Map.entities.clear();
	psli_g_Map.entities.push(psli_g_ZoomEntity[psli_g_zoomInitial - 1]);
}
 
function psli_ViewChangeEnd () {
	psli_g_Map.entities.clear();
	psli_g_Map.entities.push(psli_g_ZoomEntity[psli_g_Map.getZoom() - 1]);
}


/**************************************************************************/
// JS Function used by admin script while editing category location
function psli_CopyInitial() {
	psli_g_Vertice = new Array();
	for (var i = 0; i < psli_g_VerticeInitial.length; i++)
	{
		psli_g_Vertice.push(psli_g_VerticeInitial[i]);
	}
}

function psli_InitCategoryMap() {
	if (document.getElementById("pslibingmapsentity").value == "--null--")
	{
		document.getElementById("pslibingmapsselect").selectedIndex = 0;
		psli_g_MapOptions = 
			{credentials: psli_g_BingKey, 
			 showDashboard:false,
			 showMapTypeSelector:false,
			 showScalebar:false,
			 mapTypeId: Microsoft.Maps.MapTypeId.road,
			 center: new Microsoft.Maps.Location(0,0),
			 zoom:2
			};
	}
	else
	{
		document.getElementById("pslibingmapsselect").selectedIndex = document.getElementById("pslibingmapsaction").value;
		document.getElementById("pslibingmapsbuttonstart").disabled = false;
		psli_g_MapOptions = 
			{credentials: psli_g_BingKey, 
			 showDashboard:false,
			 showMapTypeSelector:false,
			 showScalebar:false,
			 mapTypeId: Microsoft.Maps.MapTypeId.road,
			 center: new Microsoft.Maps.Location(document.getElementById("pslibingmapslat").value, document.getElementById("pslibingmapslon").value),
			 zoom: parseInt(document.getElementById("pslibingmapsaction").value)
			};
		
	}
	
	psli_g_Map = new Microsoft.Maps.Map(document.getElementById("pslibingmapsmap"), psli_g_MapOptions);
	Microsoft.Maps.Events.addHandler(psli_g_Map, "click", psli_MapClick);	
}

function psli_SaveZone() {
	var psli_l_ZoneCoordonates = ""
	var psli_l_EntityId = document.getElementById("pslibingmapsentity").value;
	if (psli_g_Vertice.length > 0)
	{
		var psli_l_LastPoint = new Microsoft.Maps.Location(psli_g_Vertice[0].latitude, psli_g_Vertice[0].longitude);
		psli_g_Vertice.push(psli_l_LastPoint);
		var psli_l_Polygon = new Microsoft.Maps.Polygon(psli_g_Vertice,{fillColor: psli_g_PolygonColor, strokeColor: psli_g_PolygonColor});
		psli_g_Map.entities.clear();
		psli_g_Map.entities.push(psli_l_Polygon);
		for (var i = 0; i < psli_g_Vertice.length ; i++)
		{
			if (i != 0)
				psli_l_ZoneCoordonates += ",";
			psli_l_ZoneCoordonates += "(" + psli_l_EntityId + ", " + psli_g_Vertice[i].latitude + ", " + psli_g_Vertice[i].longitude + ")";
		}
		psli_l_ZoneCoordonates += ";"
	}
	else
	{
		psli_l_ZoneCoordonates = "delete all";
	}
	document.getElementById("pslibingmapszone").value = psli_l_ZoneCoordonates;
	document.getElementById("pslibingmapsbuttonall").disabled = true;
	document.getElementById("pslibingmapsbuttondelete").disabled = true;
	document.getElementById("pslibingmapsbuttonsave").disabled = true;
	document.getElementById("pslibingmapsbuttoncancel").disabled = true;
	document.getElementById("pslibingmapsbuttonstart").disabled = false;	

	psli_g_ZoneDraw = false;	
}

function psli_CancelZone() {
	psli_g_ZoneDraw = false;
	psli_CopyInitial();
	var psli_l_Polygon = new Microsoft.Maps.Polygon(psli_g_Vertice,{fillColor: psli_g_PolygonColor, strokeColor: psli_g_PolygonColor});
	psli_g_Map.entities.clear();
	psli_g_Map.entities.push(psli_l_Polygon);
	document.getElementById("pslibingmapsbuttonall").disabled = true;
	document.getElementById("pslibingmapsbuttondelete").disabled = true;
	document.getElementById("pslibingmapsbuttonsave").disabled = true;
	document.getElementById("pslibingmapsbuttoncancel").disabled = true;
	document.getElementById("pslibingmapsbuttonstart").disabled = false;	
	
}

function psli_StartZone() {
	psli_g_ZoneDraw = true;
	if (psli_g_VerticeInitial.length > 0)
	{
		psli_CopyInitial();
		var psli_l_Polygon = new Microsoft.Maps.Polygon(psli_g_Vertice,{fillColor: psli_g_PolygonColor, strokeColor: psli_g_PolygonColor});
		psli_g_Map.entities.clear();
		psli_g_Map.entities.push(psli_l_Polygon);
	}
	else
	{
		psli_g_Vertice = new Array();
		psli_g_Map.entities.clear();
	}
	document.getElementById("pslibingmapsbuttonall").disabled = false;
	document.getElementById("pslibingmapsbuttondelete").disabled = false;
	document.getElementById("pslibingmapsbuttonsave").disabled = false;
	document.getElementById("pslibingmapsbuttoncancel").disabled = false;
	document.getElementById("pslibingmapsbuttonstart").disabled = true;
	
}
				
function psli_DeleteLast() {
	if (psli_g_Vertice.length > 0) 
	{
		psli_g_Vertice.pop();
		var psli_l_Polygon = new Microsoft.Maps.Polygon(psli_g_Vertice,{fillColor: psli_g_PolygonColor, strokeColor: psli_g_PolygonColor});
		psli_g_Map.entities.clear();
		psli_g_Map.entities.push(psli_l_Polygon);
	}
}

function psli_DeleteAll() {
	psli_g_Vertice = new Array();
	psli_g_Map.entities.clear();
}

function psli_SetMinimum() {
	document.getElementById("pslibingmapszoommin").value = psli_g_Map.getZoom();
}

function psli_SetMaximum() {
	document.getElementById("pslibingmapszoommax").value = psli_g_Map.getZoom();
}

function psli_SetAction() {
	document.getElementById("pslibingmapsselect").selectedIndex = psli_g_Map.getZoom();
}

function psli_MapClick(e) {
	if (e.targetType == "map") {
		if (psli_g_ZoneDraw)
		{	
			var psli_l_Point = new Microsoft.Maps.Point(e.getX(), e.getY());
			var psli_l_Loc = e.target.tryPixelToLocation(psli_l_Point);
			psli_g_Vertice.push(psli_l_Loc);
			var zone = new Microsoft.Maps.Polygon(psli_g_Vertice,{fillColor: psli_g_PolygonColor, strokeColor: psli_g_PolygonColor});
			psli_g_Map.entities.clear();
			psli_g_Map.entities.push(zone);
		}
		else
		{
			var psli_l_Point = new Microsoft.Maps.Point(e.getX(), e.getY());
			var psli_l_Loc = e.target.tryPixelToLocation(psli_l_Point);
			
			document.getElementById("pslibingmapslat").value= psli_l_Loc.latitude;
			document.getElementById("pslibingmapslon").value= psli_l_Loc.longitude;
			document.getElementById("pslibingmapsselect").selectedIndex = psli_g_Map.getZoom();
			var pin = new Microsoft.Maps.Pushpin(psli_l_Loc);
			psli_g_Map.entities.clear();
			psli_g_Map.entities.push(pin);
		}
	}
}


